c
c Sample user coded driver program for running MARS 3.5
c
c This is a simple program to run MARS on a small data set for testing
c purposes. The input data (provided below) is assumed to be on a file
c named 'mars.data' in the local directory. Printed output (also provided
c below) is sent to the standard output (Fortran file unit 6). Note that
c this output might be slightly different than that obtained by running
c this program on a computer with different floating point arithmetic.
c The resulting model ought to be (nearly) equivalent.
c
c This program provides only the minimal input necessary to run MARS. It
c thereby makes maximal use of internally supplied defaults, and therefore
c does not take advantage of the many user options available for guiding
c the analysis (see MARS documentation).
c
c set up Maximum  problem dependent parameters for this (small) example:
c  1025 observations (cases).
c   32 predictor variables (inputs).
c   2 variable interactions maximum.
c  15 basis functions maximum.
c  1024 Test cases
c
      subroutine mainmars(np, n, ntest, mi, nk, x, y, xxx, f, w, lx)


c      parameter (n=1025, np=32,  nnn=1024)

c set up (generic) graphics parameters:
c 100 raster points for curves.
c  40 raster points (on each axis) for surfaces.
c  plot piecewise-cubic (continuous derivative) model.
c  show surfaces inside respective bivariate convex hulls.
      parameter (ngc=100, ngs=40, m=2, icx=1)
c
c  set up working storage:
c  constant dimensioned arrays may need to be set to larger values
c  for much larger problems (see MARS documentation).
c

      real x(n,np),y(n),w(n), f(ntest)
      integer lx(np)

      real xxx(ntest,np)
      real fm(50000),sp(200000)
      integer im(50000),mm(50000)
      double precision dp(200000)
      character*66 trainFile, testFile, outFile



c
c set predictor variable flags to indicate all are unrestricted
c ordinal variables, and set observation weights:
c
      do 1 i = 1,np
 1       lx(i) = 1


c
c invoke MARS:
c
      call mars (n,np,x,y,w,nk,mi,lx,fm,im,sp,dp,mm)

      do 5 i=1,ntest
      f(i)= 0.0
    5 continue

      call fmod (m,ntest,xxx,fm,im,f,sp)

      return
      end
c




